unit calc;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TCalcForm = class(TForm)
    AnswerEdit: TEdit;
    ClearButton: TButton;
    OffButton: TButton;
    ZeroButton: TButton;
    OneButton: TButton;
    TwoButton: TButton;
    ThreeButton: TButton;
    FourButton: TButton;
    FiveButton: TButton;
    SixButton: TButton;
    SevenButton: TButton;
    EightButton: TButton;
    NineButton: TButton;
    DecButton: TButton;
    DivButton: TButton;
    TimesButton: TButton;
    MinusButton: TButton;
    PlusButton: TButton;
    EqualsButton: TButton;
    procedure OffButtonClick(Sender: TObject);
    procedure OneButtonClick(Sender: TObject);
    procedure ClearButtonClick(Sender: TObject);
    procedure PlusButtonClick(Sender: TObject);
    procedure EqualsButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  CalcForm: TCalcForm;

implementation

{$R *.dfm}

var number, total : real;
    first  : boolean = true;
    operation : char;

procedure TCalcForm.OffButtonClick(Sender: TObject);
begin
        Application.Terminate;
end;

procedure TCalcForm.OneButtonClick(Sender: TObject);
//Add button caption to answer display
var button : string;
begin
        if sender = ZeroButton then      //Determine button chosen
                button := '0';
        if sender = OneButton then    
                button := '1';
        if sender = TwoButton then
                button := '2';
        if sender = ThreeButton then
                button := '3';
        if sender = FourButton then
                button := '4';
        if sender = FiveButton then
                button := '5';
        if sender = SixButton then
                button := '6';
        if sender = SevenButton then
                button := '7';
        if sender = EightButton then
                button := '8';
        if sender = NineButton then
                button := '9';
        if sender = DecButton then
                button := '.';
        AnswerEdit.Text := AnswerEdit.Text + button;   //Update display
end;

procedure TCalcForm.ClearButtonClick(Sender: TObject);
//Clear answer display
begin
        AnswerEdit.Text := '';
end;

procedure TCalcForm.PlusButtonClick(Sender: TObject);
//Carry out calculation operation
var button : char;
begin
        if sender = PlusButton then     //Determine operation chosen
                button := '+';
        if sender = MinusButton then
                button := '-';
        if sender = TimesButton then
                button := 'x';
        if sender = DivButton then
                button := '/';
        number := StrToFloat(AnswerEdit.Text);
        AnswerEdit.Text := '';          //Clear answer display
        if first then
                begin
                total := number;        //Store first value entered
                first := false;
                end
        else                            //Carry out calculation
                case operation of
                '+' : total := total + number;
                '-' : total := total - number;
                'x' : total := total * number;
                '/' : total := total / number;
                end;
        operation := button;            //Store operation for = calculation
end;

procedure TCalcForm.EqualsButtonClick(Sender: TObject);
//Carry out final calculation
begin
        number := StrToFloat(AnswerEdit.Text);
        case operation of
                '+' : total := total + number;
                '-' : total := total - number;
                'x' : total := total * number;
                '/' : total := total / number;
                end;
        AnswerEdit.Text := FloatToStr(total);
        first := true;                  //Reset first value flag
end;

end.
